#include "ws2812.h"
#include "AI8H.h"
#include <intrins.h>
#include "Delay.h"


uint8_t led_states[3][3];


void reset_all()
{
    uint8_t index;


    for (index = 0; index < 24 * LED_NUMBER; index++)
    {
        ZERO_CODE();
    }


    Delay55us();
}


void set_led_color(uint8_t led_index, uint8_t green, uint8_t red, uint8_t blue)
{
    uint8_t i;
    uint8_t mask, number;


    green = (green * BRIGHTNESS) / MAX_BRIGHTNESS;
    red = (red * BRIGHTNESS) / MAX_BRIGHTNESS;
    blue = (blue * BRIGHTNESS) / MAX_BRIGHTNESS;


    led_states[led_index][0] = green;
    led_states[led_index][1] = red;
    led_states[led_index][2] = blue;

    for (number = 0; number < LED_NUMBER; number++)
    {

        for (i = 0; i < 8; i++)
        {
            mask = 0x80 >> i;
            if (led_states[number][0] & mask)
            {
                ONE_CODE();
            }
            else
            {
                ZERO_CODE();
            }
        }
        for (i = 0; i < 8; i++)
        {
            mask = 0x80 >> i;
            if (led_states[number][1] & mask)
            {
                ONE_CODE();
            }
            else
            {
                ZERO_CODE();
            }
        }
        for (i = 0; i < 8; i++)
        {
            mask = 0x80 >> i;
            if (led_states[number][2] & mask)
            {
                ONE_CODE();
            }
            else
            {
                ZERO_CODE();
            }
        }
    }
    Delay55us();
}